#include"au3/curl.au3"

;~ If Not _CURL_Load(@ScriptDir&'\bin') Then _
If Not _CURL_Load('') Then _
		Exit MsgBox(32, 'Error', "libCURL or one of its dependencies was not found." & @CRLF & _
			"Required DLLs: libcurl.dll, libeay32.dll, libidn-11.dll, libssl32.dll, libssh2.dll, zlib1.dll")

_curl_global_init($CURL_GLOBAL_ALL) ; init all possible things (SSL, win32-socket, ...)

$hHandle = _curl_easy_init()

$hCallback = _CURL_Write_Callback_Register('_write_data')
_curl_easy_setopt($hHandle, $CURLOPT_WRITEFUNCTION, DllCallbackGetPtr($hCallback))

_curl_easy_setopt($hHandle, $CURLOPT_URL, "http://www.autoit.de")

$gsReceiveData=Binary('')
_curl_easy_perform($hHandle)

Local $sType
_curl_easy_getinfo($hHandle, $CURLINFO_CONTENT_TYPE,$sType)
MsgBox(0, 'Encoding', $sType)

Switch StringInStr($sType, "charset=UTF-8")
	Case 0
		$gsReceiveData = BinaryToString($gsReceiveData, 0)
	Case Else
		$gsReceiveData = BinaryToString($gsReceiveData, 4)
EndSwitch
MsgBox(0, '', $gsReceiveData)

_curl_easy_cleanup($hHandle)
DllCallbackFree($hCallback)

_curl_global_cleanup()


Func _write_data($buffer, $size, $nitems, $outstream)
	; exmample callback function
;~ 	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_write_callback" &@CRLF & _
;~ 		"Buffer: " & $buffer		& @CRLF & _
;~ 		"size: " & $size & @CRLF & _
;~ 		"nitems: " & $nitems & @CRLF & _
;~ 		"outstream: " & $outstream & @CRLF & _
;~ 		'')
	Local $stBuffer = DllStructCreate("byte[" & $nitems*$size & "]", $buffer)
	$gsReceiveData &= DllStructGetData($stBuffer,1)
	Return $nitems*$size ; return read size (smaller to abort)
EndFunc
